"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var loader_utils_1 = __importDefault(require("loader-utils"));
var main_1 = require("./main");
var injectLoader = function (source) {
    var options = loader_utils_1.default.getOptions(this);
    var func = function () { return ''; };
    if (main_1.registry[options.id]) {
        func = main_1.registry[options.id];
    }
    var rtn = func.call(this, source);
    if (rtn instanceof Promise) {
        var callback_1 = this.async();
        rtn
            .then(function (result) {
            callback_1 && callback_1(null, result);
        })
            .catch(function (err) {
            callback_1 && callback_1(err, undefined);
        });
        return undefined;
    }
    return rtn;
};
exports.default = injectLoader;
//# sourceMappingURL=webpack-inject-plugin.loader.js.map